from __future__ import print_function
import time
import sys
import TSP_Utilities

def bf(weg,weglaenge,rest,optweg,optlaenge,a,n,counter):

# Ausprobieren aller Moeglichkeiten; erste Stadt ist fest gesetzt

# weg:  aktuelle Tour
# rest: noch zu besuchende Orte
# a:    Distanzmatrix
# n:    Gesamtzahl der Staedte

   for i in rest:
      aktlaenge = weglaenge
      aktweg = weg[:]
      aktrest = rest[:]
      aktweg.append(i)
      aktrest.remove(i)
      l=len(aktweg)
      if l<n:
         if l >1:
            # berechne Laenge des aktuellen Weges
            aktlaenge = aktlaenge+a[aktweg[l-2]][aktweg[l-1]]
         # verlaengere aktuelle Tour um eine weitere Stadt
         optweg, optlaenge, counter=bf(aktweg,aktlaenge,aktrest,optweg,optlaenge,a,n,counter) 
      else:
         counter = counter + 1
         # Berechne Laenge der aktuellen Tour
         aktlaenge = aktlaenge+a[aktweg[0]][aktweg[n-1]]+a[aktweg[n-2]][aktweg[n-1]]
         # checke, ob aktuelle Tour kuerzer ist; wenn ja, dann speichere
         # aktuelle Tour als (bisher) optimale Tour
         if aktlaenge < optlaenge:
            optlaenge = aktlaenge
            optweg = aktweg[:]
            print ("neue kuerzeste Rundreise gefunden:", optweg,optlaenge)
   return optweg, optlaenge, counter

def bfa(a,n):

# Ausprobieren aller Moeglichkeiten; erste Stadt ist fest gesetzt

   counter = 0
   weg = [0]
   optweg = []
   weglaenge=0
   rest = range(1,n)
   optlaenge=sys.maxsize
   optweg, optlaenge, counter = bf(weg,weglaenge,rest,optweg,optlaenge,a,n,counter)
   return optweg, optlaenge, counter
      
#################
# HAUPTPROGRAMM #
#################

n=100
while n > 13 or n < 2:
   n=input("Anzahl n der Staedte, durch die eine moeglichst kurze Rundreise gesucht ist (2<n<14); Vorsicht: fuer grosse Werte von n werden die Rechenzeiten sehr gross!: ")

file_name = "rundreise_input_40.txt"
# Entfernungsmatrix einlesen
distance = TSP_Utilities.read_distance(file_name,n)
print("Read distance matrix from file", file_name)

# Ausprobieren aller Moeglichkeiten
time1=time.time()
optweg, optlaenge, counter = bfa(distance,n)
time2=time.time()
print ("Es wurden ",counter," Moeglichkeiten untersucht.")
print ("Kuerzeste Rundreise beim Ausprobieren aller Moeglichkeiten: ",optweg)
print ("Laenge: ", optlaenge)
print ("Zeit zum Ausprobieren aller Moeglichkeiten: ", time2-time1)

sys.stdin.readline()
